VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "PDU"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Function PadZero(ByVal str As String, ByVal bytLength As Byte) As String
    While (Len(str) < bytLength)
        str = "0" & str
    Wend
    PadZero = str
End Function

Private Function BCDEncode(ByVal byt As Byte) As String
    BCDEncode = PadZero(Hex(byt), 2)
End Function

Private Function EncodeAddress(ByVal strAddress As String, ByVal blnCountBytes As Boolean) As String

    Const bytInternational As Byte = &H91
    Const bytUnknown As Byte = &H81
    
    Dim bytNrPrefix As Byte
    Dim bytLenAddress As Byte
    
    If (Len(strAddress) = 0) Then
        'Return zero if no address specified
        EncodeAddress = BCDEncode(&H0)
        Exit Function
    End If

    'Check destination address and calculate
    'Type-of-number and Numbering Plan Identification
    If (Left(strAddress, 1) = "+") Then
        bytNrPrefix = bytInternational
        'Strip away first character
        strAddress = Right(strAddress, Len(strAddress) - 1)
    Else
        bytNrPrefix = bytUnknown
    End If
    
    If Not blnCountBytes Then bytLenAddress = Len(strAddress) 'original length
    
    'Check if destination address is odd
    If ((Len(strAddress) And 1) <> 0) Then
        'Pad address with an "F" to make it even length
        strAddress = strAddress & "F"
    End If
    
    'Encode address
    Dim strEncTemp As String
    Dim I As Integer
    For I = 0 To Len(strAddress) - 1 Step 2
        strEncTemp = strEncTemp & StrReverse(Mid(strAddress, I + 1, 2))
    Next I
    
    If blnCountBytes Then bytLenAddress = (Len(strEncTemp) / 2) + 1 'plus prefix byte

    EncodeAddress = BCDEncode(bytLenAddress) & BCDEncode(bytNrPrefix) & strEncTemp
End Function

Private Function EncodeSMSCAddress(ByVal strAddress As String) As String
    EncodeSMSCAddress = EncodeAddress(strAddress, True)
End Function

Private Function EncodeDestinationAddress(ByVal strAddress As String) As String
    EncodeDestinationAddress = EncodeAddress(strAddress, False)
End Function

'For EncodeUserData
Function Bin(ByVal Value As Long, Optional digits As Long = -1) As String
     Dim result As String, exponent As Integer
     ' this is faster than creating the string by appending chars
     result = String$(32, "0")
     Do
         If Value And Power2(exponent) Then
             ' we found a bit that is set, clear it
             Mid$(result, 32 - exponent, 1) = "1"
             Value = Value Xor Power2(exponent)
         End If
         exponent = exponent + 1
     Loop While Value
     If digits < 0 Then
         ' trim non significant digits, if digits was omitted or negative
         Bin = Mid$(result, 33 - exponent)
     Else
         ' else trim to the requested number of digits
         Bin = Right$(result, digits)
     End If
End Function

'For EncodeUserData
Function BinToDec(Value As String) As Long
     Dim result As Long, I As Integer, exponent As Integer
     For I = Len(Value) To 1 Step -1
         Select Case Asc(Mid$(Value, I, 1))
             Case 48      ' "0", do nothing
             Case 49      ' "1", add the corresponding power of 2
                 result = result Or Power2(exponent)
             Case Else
                 Err.Raise 5      ' Invalid procedure call or argument
         End Select
         exponent = exponent + 1
     Next
     BinToDec = result
End Function

'For Bin/BinToDec
Function Power2(ByVal exponent As Long) As Long
     Static res(0 To 31) As Long
     Dim I As Long

     ' rule out errors
     If exponent < 0 Or exponent > 31 Then Err.Raise 5

     ' initialize the array at the first call
     If res(0) = 0 Then
         res(0) = 1
         For I = 1 To 30
             res(I) = res(I - 1) * 2
         Next
         ' this is a special case
         res(31) = &H80000000
     End If

     ' return the result
     Power2 = res(exponent)

End Function

Private Function EncodeUserData(ByVal strUserData As String) As String

    Dim res As String, res2 As String, encSMS As String, lenEmNr As Long, lenSMS As Long
    Dim encRecNr As String, intNrPrefix As String
    Dim I As Long
   
   lenSMS = Len(strUserData)
   
    'Convert to 7-bit bitstream, reverse bits
    For I = 0 To Len(strUserData) - 1
        res = res + StrReverse(Bin(CLng(Asc(Mid$(strUserData, I + 1, 1))), 7))
    Next I
   
    'Check whether the string length can be divided by 8 without fractions.
    I = Len(res) And 7
    If I <> 0 Then
        res = res & String(8 - I, "0")
    End If
   
    For I = 0 To Len(res) - 1 Step 8
        res2 = StrReverse(Mid$(res, I + 1, 8))
        encSMS = encSMS & Hex(BinToDec(Left$(res2, 4))) & Hex(BinToDec(Right$(res2, 4)))
    Next I
   
    encSMS = Right$("00" & Hex(lenSMS), 2) & encSMS
    
    EncodeUserData = encSMS
End Function

Function MapChar(ByVal c As String, ByRef blnEscapeChar As Boolean) As Byte

    Dim retval As Byte
    If Len(c) > 1 Then
        c = Left(c, 1)
    ElseIf Len(c) < 1 Then
        Err.Raise 5 'invalid
        Exit Function
    End If
    
    blnEscapeChar = False
    
    Select Case c
        Case "@": retval = 0
        Case "": retval = 1
        Case "$": retval = 2
        Case "": retval = 3
        Case "": retval = 4
        Case "": retval = 5
        Case "": retval = 6
        Case "": retval = 7
        Case "": retval = 8
        Case "": retval = 9
        Case "": retval = 11
        Case "$": retval = 12
        Case "": retval = 14
        Case "": retval = 15
        Case "_": retval = 17
        Case "^": retval = 20: blnEscapeChar = True
        Case "": retval = 28
        Case "": retval = 29
        Case "": retval = 30
        Case "": retval = 31
        Case "": retval = 36
        Case "{": retval = 40: blnEscapeChar = True
        Case "}": retval = 41: blnEscapeChar = True
        Case "\": retval = 47: blnEscapeChar = True
        Case "[": retval = 60: blnEscapeChar = True
        Case "]": retval = 61: blnEscapeChar = True
        Case "~": retval = 62: blnEscapeChar = True
        Case "|": retval = 64: blnEscapeChar = True
        Case "": retval = 91
        Case "": retval = 92
        Case "": retval = 93
        Case "": retval = 94
        Case "": retval = 95
        Case "": retval = 96
        Case "": retval = 101: blnEscapeChar = True
        Case "": retval = 123
        Case "": retval = 124
        Case "": retval = 125
        Case "": retval = 126
        Case "": retval = 127
        Case Else: retval = Asc(c)
    End Select

    MapChar = retval
End Function

Private Function MapTo7BitAlphabet(ByVal strData As String)

    'Convert to user data 7 bit alphabet
    Dim strNewData As String
    Dim strNewChar As String
    Dim blnEscapeChar As Boolean
    Dim I As Long
    strNewData = ""
    
    For I = 1 To Len(strData)
        strNewChar = Chr(MapChar(Mid(strData, I, 1), blnEscapeChar))
        If blnEscapeChar Then strNewData = strNewData & Chr(27)
        strNewData = strNewData & strNewChar
    Next
    MapTo7BitAlphabet = strNewData
End Function

Public Function EncodePDU( _
    ByVal strUserData As String, _
    ByVal strDestinationAddress As String, _
    ByVal strSMSCAddress As String, _
    ByRef intActualPDULength As Integer, _
    Optional ByVal blnIncludeSMSC As Boolean = True) As String
    
    Dim bytMessageFlags As Byte
    Dim bytMsgRef As Byte
    Dim bytPID As Byte
    Dim bytDCS As Byte
    Dim bytValidityPeriodRelative As Byte
    
    bytMessageFlags = &H11 'no reply, no user data header, no status report,
                         'relative validity, do not reject duplicates,
                         'type = SMS-SUBMIT
    bytMsgRef = &H0      '0 = returned by device
    bytPID = &H0 'no telematic interworking, SME-to-SME protocol
    bytDCS = &H0 'general data coding, uncompressed, no message class,
                 'default alphabet, message class 0 (immediate display)
                 'all zero = special case, default alphabet as in Phase 2
    bytValidityPeriodRelative = &HA7 '24 hours

    Dim strEncSMSC As String
    Dim strEncPDU As String

    strEncSMSC = EncodeSMSCAddress(strSMSCAddress)
    strEncPDU = _
        BCDEncode(bytMessageFlags) & _
        BCDEncode(bytMsgRef) & _
        EncodeDestinationAddress(strDestinationAddress) & _
        BCDEncode(bytPID) & _
        BCDEncode(bytDCS) & _
        BCDEncode(bytValidityPeriodRelative) & _
        EncodeUserData(MapTo7BitAlphabet(strUserData))
    
    intActualPDULength = Len(strEncPDU) / 2
    
    EncodePDU = IIf(blnIncludeSMSC, strEncSMSC, "") & strEncPDU
End Function
   
